%% definice obrazku a cesty k nim
clear all;
images = {'1_1.tif' '1_2.tif' '2_2.tif' '2_7.tif' '3_1.tif' '3_5.tif' '10_1.tif'... % 1 - 7
'10_2.tif' '12_1.tif' '12_2.tif' '15_3.tif' '15_6.tif' '25_2.tif' '25_5.tif'... % 8 - 14
'33_2.tif' '33_6.tif' '40_2.tif' '40_5.tif'}; % 15 - 18
imdir = 'images';

% nacteni obrazku
cislo_obr = 1;
im = imread([imdir '/' images{cislo_obr}]);

%% segmentace
% pouziti:
% [imSegmented imContour] = segmentimage(im, blkSize);
%   im - vstupni obrazek
%   blkSize - velikost bloku

[imSegmented imContour] = segmentimage(im, 10);
figure; subplot(121); imshow(im); title('otisk')
subplot(122); imshow(im); hold on
[xc, yc]= find(imContour); 
plot(yc, xc, '.'); title('segmentace otisku od pozadi')

%% orientacni pole
% orientationArray = computeorientationarray(imOriginal, contour, blkSize)
%   blkSIze - velikost bloku

orientationArray = computeorientationarray(im, imSegmented, 10);
figure; h = subplot(121);
showorientationfield(im, imContour, imSegmented, orientationArray, h); title('orientacni pole');
subplot(122); imshow(orientationArray / pi + .5); title('orientace pixelu v sede skale');

%% frekvencni pole
% frequencyArray = computelocalfrequency(im, imSegmented, orientationArray)
%   im - vstupni obrazek
%   imSegmented - segmentovany obrazek (vystup segmentimage)
%   orientationArray - orientacni pole (vystup computeorientationarray)

frequencyArray = computelocalfrequency(im, imSegmented, orientationArray);
figure; h = subplot(121);
imshow(im); title('puvodni otisk');
subplot(122); imshow(frequencyArray / max(frequencyArray(:))); 
title('frekvence papilarnich linii');

%% vylepseni kresby pomoci Gaborovych filtru + tvorba skeletonu
% [imReconstruct imBinary imSkeleton] = enhance2ridgevalley(im, imSegmented, 
%   orientationArray, frequencyArray, filtoff)
%       im - vstupni obrazek
%       imSegmented - segmentovany obrazek
%       orientationArray - orientacni pole
%       frequencyArray - frekvencni pole
%       filtoff - vypnuti Gaborovy filtrace (1 - vypnuta, 0 - zapnuta)

[imReconstruct imBinary imSkeleton] = enhance2ridgevalley(im, imSegmented, orientationArray, frequencyArray, 0);
figure; subplot(121);
imshow(imReconstruct); title('obraz vylepseni pouzitim Gaborovych filtru');
subplot(122); imshow(imSkeleton); title('kostra otisku pred cistenim');

%% vycisteni skeletonu + finalni minutia
[imSkeleton minutiaArray] = cleanskeleton(im, imSegmented, imContour, imSkeleton, orientationArray);
[minArray minRot] = findminutia(imSkeleton, imContour, frequencyArray, orientationArray);
figure; subplot(121); imshow(full(imSkeleton)); title('kostra otisku po vycisteni')
subplot(122); imshow(im); hold on
[x1 y1] = find(minArray == 1); [x2 y2] = find(minArray == 2);
plot(y1,x1,'r.','markersize',8); plot(y2,x2,'ob','markersize',8);
legend('End of Ridge', 'Bifurcation');
title('v otisku vyznacene markanty')
